--- /usr/ports/Mk/bsd.xfce.mk	2010-05-31 17:27:21.000000000 +0200
+++ Mk/bsd.xfce.mk	2011-01-03 22:11:20.000000000 +0100
@@ -12,36 +12,46 @@
 # desktop environment. It's automatically included when USE_XFCE
 # is defined in the ports' makefile.
 
-_USE_XFCE_ALL=			configenv libexo libgui libmenu libutil panel \
-				thunar wm xfconf xfdev
+_USE_XFCE_ALL=			configenv garcon libexo libgui libui libutil panel \
+				thunar wm xfcehack xfconf xfdev
 
-MASTER_SITE_SUBDIR?=		xfce/4.6.2/src
+MASTER_SITE_SUBDIR?=		xfce/4.8pre3/src
 
 configenv_CONFIGURE_ENV=	CPPFLAGS="${CPPFLAGS} -I${LOCALBASE}/include -L${LOCALBASE}/lib"
 
-libexo_BUILD_DEPENDS=		libexo>=0.3.107:${PORTSDIR}/x11/libexo
-libexo_RUN_DEPENDS=		libexo>=0.3.107:${PORTSDIR}/x11/libexo
+# Since xfce4-panel 4.7.7 desktop files go into
+# ${DATADIR}/xfce4/panel/plugins rather than
+# ${DATADIR}/xfce4/panel-plugins
+xfcehack_PRE_PATCH=	${FIND} ${WRKSRC} -name "Makefile.in*" -type f \
+		| ${XARGS} ${REINPLACE_CMD} -e \
+				's|(datadir)/xfce4/panel-plugins|(datadir)/xfce4/panel/plugins|g'
 
-libgui_BUILD_DEPENDS=		libxfce4gui>=4.6.4:${PORTSDIR}/x11-toolkits/libxfce4gui
-libgui_RUN_DEPENDS=		libxfce4gui>=4.6.4:${PORTSDIR}/x11-toolkits/libxfce4gui
+libexo_BUILD_DEPENDS=		libexo>=0.5.6:${PORTSDIR}/x11/libexo
+libexo_RUN_DEPENDS=		libexo>=0.5.6:${PORTSDIR}/x11/libexo
 
-libmenu_BUILD_DEPENDS=		libxfce4menu>=4.6.2:${PORTSDIR}/x11/libxfce4menu
-libmenu_RUN_DEPENDS=		libxfce4menu>=4.6.2:${PORTSDIR}/x11/libxfce4menu
+libgui_BUILD_DEPENDS=		libxfce4gui>=4.7.0:${PORTSDIR}/x11-toolkits/libxfce4gui
+libgui_RUN_DEPENDS=		libxfce4gui>=4.7.0:${PORTSDIR}/x11-toolkits/libxfce4gui
 
-libutil_BUILD_DEPENDS=		libxfce4util>=4.6.2:${PORTSDIR}/x11/libxfce4util
-libutil_RUN_DEPENDS=		libxfce4util>=4.6.2:${PORTSDIR}/x11/libxfce4util
+libui_BUILD_DEPENDS=		libxfce4ui>=4.7.6:${PORTSDIR}/x11-toolkits/libxfce4ui
+libui_RUN_DEPENDS=		libxfce4ui>=4.7.6:${PORTSDIR}/x11-toolkits/libxfce4ui
 
-panel_BUILD_DEPENDS=		xfce4-panel>=4.6.4:${PORTSDIR}/x11-wm/xfce4-panel
-panel_RUN_DEPENDS=		xfce4-panel>=4.6.4:${PORTSDIR}/x11-wm/xfce4-panel
+garcon_BUILD_DEPENDS=		xfce4-garcon>=0.1.4:${PORTSDIR}/x11/xfce4-garcon
+garcon_RUN_DEPENDS=		xfce4-garcon>=0.1.4:${PORTSDIR}/x11/xfce4-garcon
 
-thunar_BUILD_DEPENDS=		Thunar>=1.0.2:${PORTSDIR}/x11-fm/thunar
-thunar_RUN_DEPENDS=		Thunar>=1.0.2:${PORTSDIR}/x11-fm/thunar
+libutil_BUILD_DEPENDS=		libxfce4util>=4.7.5:${PORTSDIR}/x11/libxfce4util
+libutil_RUN_DEPENDS=		libxfce4util>=4.7.5:${PORTSDIR}/x11/libxfce4util
 
-wm_BUILD_DEPENDS=		xfce4-wm>=4.6.2:${PORTSDIR}/x11-wm/xfce4-wm
-wm_RUN_DEPENDS=			xfce4-wm>=4.6.2:${PORTSDIR}/x11-wm/xfce4-wm
+panel_BUILD_DEPENDS=		xfce4-panel>=4.7.7:${PORTSDIR}/x11-wm/xfce4-panel
+panel_RUN_DEPENDS=		xfce4-panel>=4.7.7:${PORTSDIR}/x11-wm/xfce4-panel
 
-xfconf_BUILD_DEPENDS=		xfce4-conf>=4.6.2:${PORTSDIR}/x11/xfce4-conf
-xfconf_RUN_DEPENDS=		xfce4-conf>=4.6.2:${PORTSDIR}/x11/xfce4-conf
+thunar_BUILD_DEPENDS=		Thunar>=1.1.6:${PORTSDIR}/x11-fm/thunar
+thunar_RUN_DEPENDS=		Thunar>=1.1.6:${PORTSDIR}/x11-fm/thunar
+
+wm_BUILD_DEPENDS=		xfce4-wm>=4.7.4:${PORTSDIR}/x11-wm/xfce4-wm
+wm_RUN_DEPENDS=			xfce4-wm>=4.7.4:${PORTSDIR}/x11-wm/xfce4-wm
+
+xfconf_BUILD_DEPENDS=		xfce4-conf>=4.7.5:${PORTSDIR}/x11/xfce4-conf
+xfconf_RUN_DEPENDS=		xfce4-conf>=4.7.5:${PORTSDIR}/x11/xfce4-conf
 
 xfdev_RUN_DEPENDS=		xfce4-dev-tools:${PORTSDIR}/devel/xfce4-dev-tools
 
@@ -56,6 +66,10 @@
 LIB_DEPENDS+=	${${component}_LIB_DEPENDS}
 RUN_DEPENDS+=	${${component}_RUN_DEPENDS}
 CONFIGURE_ENV+=	${${component}_CONFIGURE_ENV}
+
+.if defined(${component}_PRE_PATCH)
+XFCE_PRE_PATCH+=	${${component}_PRE_PATCH}
+.endif
 .endfor
 
 .for component in ${USE_XFCE}
@@ -64,4 +78,11 @@
 . endif
 .endfor
 
+.if defined(XFCE_PRE_PATCH)
+pre-patch: xfce-pre-patch
+
+xfce-pre-patch:
+	@${XFCE_PRE_PATCH}
+.endif
+
 .endif